# SPDX-FileCopyrightText: 2023 Daniel Wolf <nephatrine@gmail.com>
#
# SPDX-License-Identifier: ISC

set(CMAKE_C_OUTPUT_EXTENSION ".o")
set(CMAKE_CXX_OUTPUT_EXTENSION ".o")

if(DEFINED CMAKE_DXE3GEN)
	set(CMAKE_SHARED_LIBRARY_PREFIX "")
	set(CMAKE_SHARED_LIBRARY_SUFFIX ".DXE")
	set(CMAKE_SHARED_MODULE_PREFIX "")
	set(CMAKE_SHARED_MODULE_SUFFIX ".DXE")
	set(CMAKE_IMPORT_LIBRARY_SUFFIX ".DXE.A")

	set(CMAKE_C_CREATE_SHARED_LIBRARY "${CMAKE_DXE3GEN} <LINK_FLAGS> -o <TARGET> -Y <TARGET_IMPLIB> <OBJECTS> -U <LINK_LIBRARIES>")
	set(CMAKE_C_CREATE_SHARED_MODULE "${CMAKE_DXE3GEN} <LINK_FLAGS> -o <TARGET> <OBJECTS> -U <LINK_LIBRARIES>")

	set(CMAKE_CXX_CREATE_SHARED_LIBRARY "${CMAKE_C_CREATE_SHARED_LIBRARY}")
	set(CMAKE_CXX_CREATE_SHARED_MODULE "${CMAKE_C_CREATE_SHARED_MODULE}")
else()
	set_property(GLOBAL PROPERTY TARGET_SUPPORTS_SHARED_LIBS FALSE)
endif()
